---
product: "AG Grid"
title: "New Filters Tool Panel"
description: "The new allows accessing the grid's filters without needing to open up the column menu."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Side Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/side-bar/"
    - title: "Columns Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-columns/"
    - title: "Filters Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tool-panel-filters/"
    - title: "Custom Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-tool-panel/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# New Filters Tool Panel

The new **Filters Tool Panel** allows accessing the grid's filters without needing to open up the column menu.

## Enabling New Filters Tool Panel

#### New Filters Tool Panel

```ts
import {
  ClientSideRowModelModule,
  DateFilterModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
    floatingFilter: true,
  },
  sideBar: "filters-new",
  enableFilterHandlers: true,
  suppressSetFilterByDefault: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) =>
    gridApi!.setGridOption(
      "rowData",
      data.map((rowData) => {
        const dateParts = rowData.date.split("/");
        const [year, month, day] = dateParts
          .reverse()
          .map((e) => parseInt(e, 10));
        const paddedDateTimeStrings = [month, day].map((e) =>
          e.toString().padStart(2, "0"),
        );
        const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
        return {
          ...rowData,
          date,
        };
      }),
    ),
  );
```

[Live example: New Filters Tool Panel](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/simple/typescript/)

To use the new Filters Tool Panel, set `enableFilterHandlers = true`, and use the `'filters-new'` [Side Bar Configuration](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/side-bar/#configuring-the-side-bar).

If a filter is set from anywhere outside of the tool panel, e.g. from the column menu, the filter will automatically be added to the tool panel. Once a filter appears in the tool panel, it will remain until it's removed from within the tool panel.

## Using Buttons

The tool panel can be configured to have global [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons). These behave the same as when used within an individual filter, but instead apply to all filters at once.

To use global buttons, every filter must first be configured to use the buttons. The global buttons can then be passed to the tool panel configuration when using `agNewFiltersToolPanel`, by passing an `IToolPanelNewFiltersCompParams` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `buttons` | `FilterAction[]` |  |  |  |

The example below demonstrates using buttons with the tool panel:

#### New Filters Tool Panel Buttons

```ts
import {
  ClientSideRowModelModule,
  DateFilterModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
    filterParams: {
      defaultFilterParams: {
        buttons: ["apply"], // set all filters to use buttons
      },
    } as SelectableFilterParams,
  },
  sideBar: {
    toolPanels: [
      {
        id: "filters-new",
        labelDefault: "Filters",
        labelKey: "filters",
        iconKey: "filter",
        toolPanel: "agNewFiltersToolPanel",
        toolPanelParams: {
          buttons: ["cancel", "apply"],
        },
      },
    ],
    defaultToolPanel: "filters-new",
  },
  enableFilterHandlers: true,
  suppressSetFilterByDefault: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) =>
    gridApi!.setGridOption(
      "rowData",
      data.map((rowData) => {
        const dateParts = rowData.date.split("/");
        const [year, month, day] = dateParts
          .reverse()
          .map((e) => parseInt(e, 10));
        const paddedDateTimeStrings = [month, day].map((e) =>
          e.toString().padStart(2, "0"),
        );
        const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
        return {
          ...rowData,
          date,
        };
      }),
    ),
  );
```

[Live example: New Filters Tool Panel Buttons](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/using-buttons/typescript/)

Note that when opened from the column menu, the buttons will be visible within the individual filters. Within the tool panel, only the global buttons will be visible.

## Configuring Filters

### Changing Selectable Filters

For each column filter, the filter type can be changed by using the dropdown within the tool panel. To enable switching filters, set `filter: 'agSelectableColumnFilter'` on the column definition. For any other `filter` value, the dropdown will not be displayed.

By default, the dropdown will allow switching between:

- `Simple Filter` - [Text Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-text/), [Number Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-number/), [BigInt Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-bigint/) or [Date Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-date/), depending on the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-data-types/)
- `Selection Filter` - [Set Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set/)
- `Combo Filter` - [Multi Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-multi/) (if the `MultiFilterModule` is loaded)

To allow other filters to be configured in the dropdown, `filterParams` of type `SelectableFilterParams` can be set on the column definition:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `SelectableFilterDef[]` |  |  |  |
| `defaultFilterIndex` | `number` |  |  |  |
| `defaultFilterParams` | `FilterWrapperParams` |  |  |  |

### Suppressing Filters

To remove a particular column / filter from the tool panel, set the column property `suppressFiltersToolPanel` to `true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressFiltersToolPanel` | `boolean` |  |  |  |

### Example: Configuring Filters

The example below demonstrates configuring filters:

- The **Athlete** column does not show a dropdown as it has `filter: 'agSetColumnFilter'` set.
- The **Age** column shows all three grid-provided filter options by default.
- The **Country** column is configured to show the Set Filter before the Text Filter.
- The **Year** column is configured to show a custom filter component with the Set Filter.
- The **Date** column has `suppressFiltersToolPanel: true` set, so it does not show in the tool panel.

#### New Filters Tool Panel Configuration

```ts
import {
  ClientSideRowModelModule,
  DateFilterModule,
  DoesFilterPassParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  MultiFilterModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { YearFilter } from "./yearFilter";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  MultiFilterModule,
]);

function doesFilterPass({
  model,
  node,
  handlerParams,
}: DoesFilterPassParams<any, any, boolean>): boolean {
  return model ? handlerParams.getValue(node) > 2010 : true;
}

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", filter: "agSetColumnFilter" },
    { field: "age" },
    {
      field: "country",
      filterParams: {
        filters: [
          {
            filter: "agSetColumnFilter",
          },
          {
            filter: true, // default filter based on cell data type
          },
        ],
      } as SelectableFilterParams,
    },
    {
      field: "year",
      filterParams: {
        filters: [
          {
            filter: { component: YearFilter, doesFilterPass: doesFilterPass },
            name: "Custom Filter",
          },
          {
            filter: "agSetColumnFilter",
          },
        ],
      } as SelectableFilterParams,
    },
    { field: "date", minWidth: 180, suppressFiltersToolPanel: true },
    { field: "total", filter: false },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
  },
  sideBar: "filters-new",
  enableFilterHandlers: true,
  suppressSetFilterByDefault: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) =>
    gridApi!.setGridOption(
      "rowData",
      data.map((rowData) => {
        const dateParts = rowData.date.split("/");
        const [year, month, day] = dateParts
          .reverse()
          .map((e) => parseInt(e, 10));
        const paddedDateTimeStrings = [month, day].map((e) =>
          e.toString().padStart(2, "0"),
        );
        const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
        return {
          ...rowData,
          date,
        };
      }),
    ),
  );
```

[Live example: New Filters Tool Panel Configuration](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/configuring-filters/typescript/)

## Filters Tool Panel State

When the grid initialises, the tool panel only shows active filters provided in the [Initial State](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-state/) filter model. The tool panel can also be configured via initial state to show inactive filters, or change the order and expansion state. This is provided to the Side Bar state as a `NewFiltersToolPanelState` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `NewFiltersToolPanelFilterState[]` |  |  |  |

#### New Filters Tool Panel State

```ts
import {
  ClientSideRowModelModule,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridStateModule,
  ModuleRegistry,
  NewFiltersToolPanelState,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  GridStateModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
  },
  sideBar: "filters-new",
  enableFilterHandlers: true,
  suppressSetFilterByDefault: true,
  initialState: {
    sideBar: {
      visible: true,
      position: "right",
      openToolPanel: "filters-new",
      toolPanels: {
        "filters-new": {
          filters: [
            {
              colId: "country",
              expanded: true,
            },
            {
              colId: "age",
            },
          ],
        } as NewFiltersToolPanelState,
      },
    },
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) =>
    gridApi!.setGridOption(
      "rowData",
      data.map((rowData) => {
        const dateParts = rowData.date.split("/");
        const [year, month, day] = dateParts
          .reverse()
          .map((e) => parseInt(e, 10));
        const paddedDateTimeStrings = [month, day].map((e) =>
          e.toString().padStart(2, "0"),
        );
        const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
        return {
          ...rowData,
          date,
        };
      }),
    ),
  );
```

[Live example: New Filters Tool Panel State](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/state/typescript/)

## Filter Instances

The filters provided in the tool panel are the same instances as the filter in the column menu. This has the following implications:

- Configuration relating to filters equally applies when the filters appear in the tool panel.
- The filter behaves exactly as when it appears in the column menu. E.g. the Apply button will have the same meaning when used in the tool panel. Also the relationship with the Floating Filter (if active) will be the same.
- If the filter is open on the tool panel and then the user subsequently opens the column menu, the tool panel filter will be closed. Because the filter is the same filter instance, it will only appear at one location at any given time.


---
product: "AG Grid"
title: "New Filters Tool Panel"
description: "The new allows accessing the grid's filters without needing to open up the column menu."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Side Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/side-bar/"
    - title: "Columns Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-columns/"
    - title: "Filters Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tool-panel-filters/"
    - title: "Custom Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-tool-panel/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# New Filters Tool Panel

The new **Filters Tool Panel** allows accessing the grid's filters without needing to open up the column menu.

## Enabling New Filters Tool Panel

#### New Filters Tool Panel

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [sideBar]="sideBar"
    [enableFilterHandlers]="true"
    [suppressSetFilterByDefault]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
    floatingFilter: true,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "filters-new";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe(
        (data) =>
          (this.rowData = data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          })),
      );
  }
}
```

[Live example: New Filters Tool Panel](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/simple/angular/)

To use the new Filters Tool Panel, set `enableFilterHandlers = true`, and use the `'filters-new'` [Side Bar Configuration](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/side-bar/#configuring-the-side-bar).

If a filter is set from anywhere outside of the tool panel, e.g. from the column menu, the filter will automatically be added to the tool panel. Once a filter appears in the tool panel, it will remain until it's removed from within the tool panel.

## Using Buttons

The tool panel can be configured to have global [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons). These behave the same as when used within an individual filter, but instead apply to all filters at once.

To use global buttons, every filter must first be configured to use the buttons. The global buttons can then be passed to the tool panel configuration when using `agNewFiltersToolPanel`, by passing an `IToolPanelNewFiltersCompParams` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `buttons` | `FilterAction[]` |  |  |  |

The example below demonstrates using buttons with the tool panel:

#### New Filters Tool Panel Buttons

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [sideBar]="sideBar"
    [enableFilterHandlers]="true"
    [suppressSetFilterByDefault]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
    filterParams: {
      defaultFilterParams: {
        buttons: ["apply"], // set all filters to use buttons
      },
    } as SelectableFilterParams,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = {
    toolPanels: [
      {
        id: "filters-new",
        labelDefault: "Filters",
        labelKey: "filters",
        iconKey: "filter",
        toolPanel: "agNewFiltersToolPanel",
        toolPanelParams: {
          buttons: ["cancel", "apply"],
        },
      },
    ],
    defaultToolPanel: "filters-new",
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe(
        (data) =>
          (this.rowData = data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          })),
      );
  }
}
```

[Live example: New Filters Tool Panel Buttons](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/using-buttons/angular/)

Note that when opened from the column menu, the buttons will be visible within the individual filters. Within the tool panel, only the global buttons will be visible.

## Configuring Filters

### Changing Selectable Filters

For each column filter, the filter type can be changed by using the dropdown within the tool panel. To enable switching filters, set `filter: 'agSelectableColumnFilter'` on the column definition. For any other `filter` value, the dropdown will not be displayed.

By default, the dropdown will allow switching between:

- `Simple Filter` - [Text Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-text/), [Number Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-number/), [BigInt Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-bigint/) or [Date Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-date/), depending on the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-data-types/)
- `Selection Filter` - [Set Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set/)
- `Combo Filter` - [Multi Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-multi/) (if the `MultiFilterModule` is loaded)

To allow other filters to be configured in the dropdown, `filterParams` of type `SelectableFilterParams` can be set on the column definition:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `SelectableFilterDef[]` |  |  |  |
| `defaultFilterIndex` | `number` |  |  |  |
| `defaultFilterParams` | `FilterWrapperParams` |  |  |  |

### Suppressing Filters

To remove a particular column / filter from the tool panel, set the column property `suppressFiltersToolPanel` to `true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressFiltersToolPanel` | `boolean` |  |  |  |

### Example: Configuring Filters

The example below demonstrates configuring filters:

- The **Athlete** column does not show a dropdown as it has `filter: 'agSetColumnFilter'` set.
- The **Age** column shows all three grid-provided filter options by default.
- The **Country** column is configured to show the Set Filter before the Text Filter.
- The **Year** column is configured to show a custom filter component with the Set Filter.
- The **Date** column has `suppressFiltersToolPanel: true` set, so it does not show in the tool panel.

#### New Filters Tool Panel Configuration

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  DoesFilterPassParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  MultiFilterModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  MultiFilterModule,
]);
import { YearFilter } from "./year-filter.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, YearFilter],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [sideBar]="sideBar"
    [enableFilterHandlers]="true"
    [suppressSetFilterByDefault]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", filter: "agSetColumnFilter" },
    { field: "age" },
    {
      field: "country",
      filterParams: {
        filters: [
          {
            filter: "agSetColumnFilter",
          },
          {
            filter: true, // default filter based on cell data type
          },
        ],
      } as SelectableFilterParams,
    },
    {
      field: "year",
      filterParams: {
        filters: [
          {
            filter: { component: YearFilter, doesFilterPass: doesFilterPass },
            name: "Custom Filter",
          },
          {
            filter: "agSetColumnFilter",
          },
        ],
      } as SelectableFilterParams,
    },
    { field: "date", minWidth: 180, suppressFiltersToolPanel: true },
    { field: "total", filter: false },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "filters-new";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe(
        (data) =>
          (this.rowData = data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          })),
      );
  }
}

function doesFilterPass({
  model,
  node,
  handlerParams,
}: DoesFilterPassParams<any, any, boolean>): boolean {
  return model ? handlerParams.getValue(node) > 2010 : true;
}
```

[Live example: New Filters Tool Panel Configuration](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/configuring-filters/angular/)

## Filters Tool Panel State

When the grid initialises, the tool panel only shows active filters provided in the [Initial State](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-state/) filter model. The tool panel can also be configured via initial state to show inactive filters, or change the order and expansion state. This is provided to the Side Bar state as a `NewFiltersToolPanelState` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `NewFiltersToolPanelFilterState[]` |  |  |  |

#### New Filters Tool Panel State

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridState,
  GridStateModule,
  ModuleRegistry,
  NewFiltersToolPanelState,
  NumberFilterModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  GridStateModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [sideBar]="sideBar"
    [enableFilterHandlers]="true"
    [suppressSetFilterByDefault]="true"
    [initialState]="initialState"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: "agSelectableColumnFilter",
  };
  sideBar: SideBarDef | string | string[] | boolean | null = "filters-new";
  initialState: GridState = {
    sideBar: {
      visible: true,
      position: "right",
      openToolPanel: "filters-new",
      toolPanels: {
        "filters-new": {
          filters: [
            {
              colId: "country",
              expanded: true,
            },
            {
              colId: "age",
            },
          ],
        } as NewFiltersToolPanelState,
      },
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe(
        (data) =>
          (this.rowData = data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          })),
      );
  }
}
```

[Live example: New Filters Tool Panel State](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/state/angular/)

## Filter Instances

The filters provided in the tool panel are the same instances as the filter in the column menu. This has the following implications:

- Configuration relating to filters equally applies when the filters appear in the tool panel.
- The filter behaves exactly as when it appears in the column menu. E.g. the Apply button will have the same meaning when used in the tool panel. Also the relationship with the Floating Filter (if active) will be the same.
- If the filter is open on the tool panel and then the user subsequently opens the column menu, the tool panel filter will be closed. Because the filter is the same filter instance, it will only appear at one location at any given time.


---
product: "AG Grid"
title: "New Filters Tool Panel"
description: "The new allows accessing the grid's filters without needing to open up the column menu."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Side Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/side-bar/"
    - title: "Columns Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-columns/"
    - title: "Filters Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/tool-panel-filters/"
    - title: "Custom Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-tool-panel/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# New Filters Tool Panel

The new **Filters Tool Panel** allows accessing the grid's filters without needing to open up the column menu.

## Enabling New Filters Tool Panel

#### New Filters Tool Panel

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
      floatingFilter: true,
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) =>
        setRowData(
          data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          }),
        ),
      );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            sideBar={"filters-new"}
            enableFilterHandlers={true}
            suppressSetFilterByDefault={true}
            onGridReady={onGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: New Filters Tool Panel](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/simple/reactFunctionalTs/)

To use the new Filters Tool Panel, set `enableFilterHandlers = true`, and use the `'filters-new'` [Side Bar Configuration](https://www.ag-grid.com/archive/36.2.0/react-data-grid/side-bar/#configuring-the-side-bar).

If a filter is set from anywhere outside of the tool panel, e.g. from the column menu, the filter will automatically be added to the tool panel. Once a filter appears in the tool panel, it will remain until it's removed from within the tool panel.

## Using Buttons

The tool panel can be configured to have global [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons). These behave the same as when used within an individual filter, but instead apply to all filters at once.

To use global buttons, every filter must first be configured to use the buttons. The global buttons can then be passed to the tool panel configuration when using `agNewFiltersToolPanel`, by passing an `IToolPanelNewFiltersCompParams` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `buttons` | `FilterAction[]` |  |  |  |

The example below demonstrates using buttons with the tool panel:

#### New Filters Tool Panel Buttons

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
      filterParams: {
        defaultFilterParams: {
          buttons: ["apply"], // set all filters to use buttons
        },
      } as SelectableFilterParams,
    };
  }, []);
  const sideBar = useMemo<
    SideBarDef | string | string[] | boolean | null
  >(() => {
    return {
      toolPanels: [
        {
          id: "filters-new",
          labelDefault: "Filters",
          labelKey: "filters",
          iconKey: "filter",
          toolPanel: "agNewFiltersToolPanel",
          toolPanelParams: {
            buttons: ["cancel", "apply"],
          },
        },
      ],
      defaultToolPanel: "filters-new",
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) =>
        setRowData(
          data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          }),
        ),
      );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            sideBar={sideBar}
            enableFilterHandlers={true}
            suppressSetFilterByDefault={true}
            onGridReady={onGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: New Filters Tool Panel Buttons](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/using-buttons/reactFunctionalTs/)

Note that when opened from the column menu, the buttons will be visible within the individual filters. Within the tool panel, only the global buttons will be visible.

## Configuring Filters

### Changing Selectable Filters

For each column filter, the filter type can be changed by using the dropdown within the tool panel. To enable switching filters, set `filter: 'agSelectableColumnFilter'` on the column definition. For any other `filter` value, the dropdown will not be displayed.

By default, the dropdown will allow switching between:

- `Simple Filter` - [Text Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-text/), [Number Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-number/), [BigInt Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-bigint/) or [Date Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-date/), depending on the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-data-types/)
- `Selection Filter` - [Set Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set/)
- `Combo Filter` - [Multi Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-multi/) (if the `MultiFilterModule` is loaded)

To allow other filters to be configured in the dropdown, `filterParams` of type `SelectableFilterParams` can be set on the column definition:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `SelectableFilterDef[]` |  |  |  |
| `defaultFilterIndex` | `number` |  |  |  |
| `defaultFilterParams` | `FilterWrapperParams` |  |  |  |

### Suppressing Filters

To remove a particular column / filter from the tool panel, set the column property `suppressFiltersToolPanel` to `true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressFiltersToolPanel` | `boolean` |  |  |  |

### Example: Configuring Filters

The example below demonstrates configuring filters:

- The **Athlete** column does not show a dropdown as it has `filter: 'agSetColumnFilter'` set.
- The **Age** column shows all three grid-provided filter options by default.
- The **Country** column is configured to show the Set Filter before the Text Filter.
- The **Year** column is configured to show a custom filter component with the Set Filter.
- The **Date** column has `suppressFiltersToolPanel: true` set, so it does not show in the tool panel.

#### New Filters Tool Panel Configuration

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  DoesFilterPassParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  MultiFilterModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import YearFilter from "./yearFilter.tsx";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  MultiFilterModule,
];

const doesFilterPass: ({
  model,
  node,
  handlerParams,
}: DoesFilterPassParams<any, any, boolean>) => boolean = ({
  model,
  node,
  handlerParams,
}: DoesFilterPassParams<any, any, boolean>) => {
  return model ? handlerParams.getValue(node) > 2010 : true;
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", filter: "agSetColumnFilter" },
    { field: "age" },
    {
      field: "country",
      filterParams: {
        filters: [
          {
            filter: "agSetColumnFilter",
          },
          {
            filter: true, // default filter based on cell data type
          },
        ],
      } as SelectableFilterParams,
    },
    {
      field: "year",
      filterParams: {
        filters: [
          {
            filter: { component: YearFilter, doesFilterPass: doesFilterPass },
            name: "Custom Filter",
          },
          {
            filter: "agSetColumnFilter",
          },
        ],
      } as SelectableFilterParams,
    },
    { field: "date", minWidth: 180, suppressFiltersToolPanel: true },
    { field: "total", filter: false },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) =>
        setRowData(
          data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          }),
        ),
      );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            sideBar={"filters-new"}
            enableFilterHandlers={true}
            suppressSetFilterByDefault={true}
            onGridReady={onGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: New Filters Tool Panel Configuration](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/configuring-filters/reactFunctionalTs/)

## Filters Tool Panel State

When the grid initialises, the tool panel only shows active filters provided in the [Initial State](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-state/) filter model. The tool panel can also be configured via initial state to show inactive filters, or change the order and expansion state. This is provided to the Side Bar state as a `NewFiltersToolPanelState` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `NewFiltersToolPanelFilterState[]` |  |  |  |

#### New Filters Tool Panel State

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridState,
  GridStateModule,
  ModuleRegistry,
  NewFiltersToolPanelState,
  NumberFilterModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  GridStateModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "date", minWidth: 180 },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
    };
  }, []);
  const initialState = useMemo<GridState>(() => {
    return {
      sideBar: {
        visible: true,
        position: "right",
        openToolPanel: "filters-new",
        toolPanels: {
          "filters-new": {
            filters: [
              {
                colId: "country",
                expanded: true,
              },
              {
                colId: "age",
              },
            ],
          } as NewFiltersToolPanelState,
        },
      },
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) =>
        setRowData(
          data.map((rowData) => {
            const dateParts = rowData.date.split("/");
            const [year, month, day] = dateParts
              .reverse()
              .map((e) => parseInt(e, 10));
            const paddedDateTimeStrings = [month, day].map((e) =>
              e.toString().padStart(2, "0"),
            );
            const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
            return {
              ...rowData,
              date,
            };
          }),
        ),
      );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            sideBar={"filters-new"}
            enableFilterHandlers={true}
            suppressSetFilterByDefault={true}
            initialState={initialState}
            onGridReady={onGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: New Filters Tool Panel State](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/state/reactFunctionalTs/)

## Filter Instances

The filters provided in the tool panel are the same instances as the filter in the column menu. This has the following implications:

- Configuration relating to filters equally applies when the filters appear in the tool panel.
- The filter behaves exactly as when it appears in the column menu. E.g. the Apply button will have the same meaning when used in the tool panel. Also the relationship with the Floating Filter (if active) will be the same.
- If the filter is open on the tool panel and then the user subsequently opens the column menu, the tool panel filter will be closed. Because the filter is the same filter instance, it will only appear at one location at any given time.


---
product: "AG Grid"
title: "New Filters Tool Panel"
description: "The new allows accessing the grid's filters without needing to open up the column menu."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Side Bar"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/side-bar/"
    - title: "Columns Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-columns/"
    - title: "Filters Tool Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tool-panel-filters/"
    - title: "Custom Panel"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-tool-panel/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# New Filters Tool Panel

The new **Filters Tool Panel** allows accessing the grid's filters without needing to open up the column menu.

## Enabling New Filters Tool Panel

#### New Filters Tool Panel

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :sideBar="sideBar"
      :enableFilterHandlers="true"
      :suppressSetFilterByDefault="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "date", minWidth: 180 },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
      floatingFilter: true,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters-new",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) =>
        (rowData.value = data.map((rowData) => {
          const dateParts = rowData.date.split("/");
          const [year, month, day] = dateParts
            .reverse()
            .map((e) => parseInt(e, 10));
          const paddedDateTimeStrings = [month, day].map((e) =>
            e.toString().padStart(2, "0"),
          );
          const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
          return {
            ...rowData,
            date,
          };
        }));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: New Filters Tool Panel](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/simple/vue3/)

To use the new Filters Tool Panel, set `enableFilterHandlers = true`, and use the `'filters-new'` [Side Bar Configuration](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/side-bar/#configuring-the-side-bar).

If a filter is set from anywhere outside of the tool panel, e.g. from the column menu, the filter will automatically be added to the tool panel. Once a filter appears in the tool panel, it will remain until it's removed from within the tool panel.

## Using Buttons

The tool panel can be configured to have global [Apply, Clear, Reset and Cancel Buttons](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-applying/#apply-clear-reset-and-cancel-buttons). These behave the same as when used within an individual filter, but instead apply to all filters at once.

To use global buttons, every filter must first be configured to use the buttons. The global buttons can then be passed to the tool panel configuration when using `agNewFiltersToolPanel`, by passing an `IToolPanelNewFiltersCompParams` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `buttons` | `FilterAction[]` |  |  |  |

The example below demonstrates using buttons with the tool panel:

#### New Filters Tool Panel Buttons

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :sideBar="sideBar"
      :enableFilterHandlers="true"
      :suppressSetFilterByDefault="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "date", minWidth: 180 },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
      filterParams: {
        defaultFilterParams: {
          buttons: ["apply"], // set all filters to use buttons
        },
      } as SelectableFilterParams,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
      toolPanels: [
        {
          id: "filters-new",
          labelDefault: "Filters",
          labelKey: "filters",
          iconKey: "filter",
          toolPanel: "agNewFiltersToolPanel",
          toolPanelParams: {
            buttons: ["cancel", "apply"],
          },
        },
      ],
      defaultToolPanel: "filters-new",
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) =>
        (rowData.value = data.map((rowData) => {
          const dateParts = rowData.date.split("/");
          const [year, month, day] = dateParts
            .reverse()
            .map((e) => parseInt(e, 10));
          const paddedDateTimeStrings = [month, day].map((e) =>
            e.toString().padStart(2, "0"),
          );
          const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
          return {
            ...rowData,
            date,
          };
        }));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: New Filters Tool Panel Buttons](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/using-buttons/vue3/)

Note that when opened from the column menu, the buttons will be visible within the individual filters. Within the tool panel, only the global buttons will be visible.

## Configuring Filters

### Changing Selectable Filters

For each column filter, the filter type can be changed by using the dropdown within the tool panel. To enable switching filters, set `filter: 'agSelectableColumnFilter'` on the column definition. For any other `filter` value, the dropdown will not be displayed.

By default, the dropdown will allow switching between:

- `Simple Filter` - [Text Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-text/), [Number Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-number/), [BigInt Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-bigint/) or [Date Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-date/), depending on the [Cell Data Type](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-data-types/)
- `Selection Filter` - [Set Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set/)
- `Combo Filter` - [Multi Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-multi/) (if the `MultiFilterModule` is loaded)

To allow other filters to be configured in the dropdown, `filterParams` of type `SelectableFilterParams` can be set on the column definition:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `SelectableFilterDef[]` |  |  |  |
| `defaultFilterIndex` | `number` |  |  |  |
| `defaultFilterParams` | `FilterWrapperParams` |  |  |  |

### Suppressing Filters

To remove a particular column / filter from the tool panel, set the column property `suppressFiltersToolPanel` to `true`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressFiltersToolPanel` | `boolean` |  |  |  |

### Example: Configuring Filters

The example below demonstrates configuring filters:

- The **Athlete** column does not show a dropdown as it has `filter: 'agSetColumnFilter'` set.
- The **Age** column shows all three grid-provided filter options by default.
- The **Country** column is configured to show the Set Filter before the Text Filter.
- The **Year** column is configured to show a custom filter component with the Set Filter.
- The **Date** column has `suppressFiltersToolPanel: true` set, so it does not show in the tool panel.

#### New Filters Tool Panel Configuration

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  DoesFilterPassParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  SelectableFilterParams,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  MultiFilterModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import YearFilter from "./yearFilterVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  MultiFilterModule,
]);

function doesFilterPass({
  model,
  node,
  handlerParams,
}: DoesFilterPassParams<any, any, boolean>): boolean {
  return model ? handlerParams.getValue(node) > 2010 : true;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :sideBar="sideBar"
      :enableFilterHandlers="true"
      :suppressSetFilterByDefault="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    YearFilter,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", filter: "agSetColumnFilter" },
      { field: "age" },
      {
        field: "country",
        filterParams: {
          filters: [
            {
              filter: "agSetColumnFilter",
            },
            {
              filter: true, // default filter based on cell data type
            },
          ],
        } as SelectableFilterParams,
      },
      {
        field: "year",
        filterParams: {
          filters: [
            {
              filter: {
                component: "YearFilter",
                doesFilterPass: doesFilterPass,
              },
              name: "Custom Filter",
            },
            {
              filter: "agSetColumnFilter",
            },
          ],
        } as SelectableFilterParams,
      },
      { field: "date", minWidth: 180, suppressFiltersToolPanel: true },
      { field: "total", filter: false },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters-new",
    );
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) =>
        (rowData.value = data.map((rowData) => {
          const dateParts = rowData.date.split("/");
          const [year, month, day] = dateParts
            .reverse()
            .map((e) => parseInt(e, 10));
          const paddedDateTimeStrings = [month, day].map((e) =>
            e.toString().padStart(2, "0"),
          );
          const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
          return {
            ...rowData,
            date,
          };
        }));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: New Filters Tool Panel Configuration](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/configuring-filters/vue3/)

## Filters Tool Panel State

When the grid initialises, the tool panel only shows active filters provided in the [Initial State](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-state/) filter model. The tool panel can also be configured via initial state to show inactive filters, or change the order and expansion state. This is provided to the Side Bar state as a `NewFiltersToolPanelState` object:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `filters` | `NewFiltersToolPanelFilterState[]` |  |  |  |

#### New Filters Tool Panel State

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DateFilterModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridState,
  GridStateModule,
  ModuleRegistry,
  NewFiltersToolPanelState,
  NumberFilterModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  NewFiltersToolPanelModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberFilterModule,
  DateFilterModule,
  ClientSideRowModelModule,
  NewFiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  TextFilterModule,
  GridStateModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :sideBar="sideBar"
      :enableFilterHandlers="true"
      :suppressSetFilterByDefault="true"
      :initialState="initialState"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "date", minWidth: 180 },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      filter: "agSelectableColumnFilter",
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
      "filters-new",
    );
    const initialState = ref<GridState>({
      sideBar: {
        visible: true,
        position: "right",
        openToolPanel: "filters-new",
        toolPanels: {
          "filters-new": {
            filters: [
              {
                colId: "country",
                expanded: true,
              },
              {
                colId: "age",
              },
            ],
          } as NewFiltersToolPanelState,
        },
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) =>
        (rowData.value = data.map((rowData) => {
          const dateParts = rowData.date.split("/");
          const [year, month, day] = dateParts
            .reverse()
            .map((e) => parseInt(e, 10));
          const paddedDateTimeStrings = [month, day].map((e) =>
            e.toString().padStart(2, "0"),
          );
          const date = `${year}-${paddedDateTimeStrings[0]}-${paddedDateTimeStrings[1]}`;
          return {
            ...rowData,
            date,
          };
        }));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      sideBar,
      initialState,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: New Filters Tool Panel State](https://www.ag-grid.com/archive/36.2.0/examples/tool-panel-filters-new/state/vue3/)

## Filter Instances

The filters provided in the tool panel are the same instances as the filter in the column menu. This has the following implications:

- Configuration relating to filters equally applies when the filters appear in the tool panel.
- The filter behaves exactly as when it appears in the column menu. E.g. the Apply button will have the same meaning when used in the tool panel. Also the relationship with the Floating Filter (if active) will be the same.
- If the filter is open on the tool panel and then the user subsequently opens the column menu, the tool panel filter will be closed. Because the filter is the same filter instance, it will only appear at one location at any given time.
